#include <clip.h>

#define PATCH_ON		1

#define TARGET_CPU_CLOCK	4000000
#define TARGET_FPS		60

typedef struct _TARGET {
	Z80 z80;
	unsigned char mem[0x10000];
} TARGET;

typedef struct _ROM {
	const char* name;
	unsigned short base;
	unsigned short size;
	unsigned crc;
} ROM;

#define ROMSET_FNAME		"minivadr.zip"

extern unsigned char vbuff[DISP_X * DISP_Y];
extern int joy;
extern unsigned char color_table[1 << 6];

unsigned char target_z80_read(Z80* z80, unsigned short addr);
void target_z80_write(Z80* z80, unsigned short addr, unsigned char data);
unsigned char target_z80_in(Z80* z80, unsigned short addr);
void target_z80_out(Z80* z80, unsigned short addr, unsigned char data);
void update_video(TARGET* target);
void update_input(TARGET* target);

