/*
 *	fram.c
 *
 *	~jx[_[/EMU
 *
 *	* Tue Nov 28 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

unsigned char
target_z80_read(Z80* z80, unsigned short addr)
{
	TARGET* target = (TARGET*)z80;
	return target->mem[addr];
}

void
target_z80_write(Z80* z80, unsigned short addr, unsigned char data)
{
	TARGET* target = (TARGET*)z80;
	if(addr == 0xe008) {
		/** ??? **/
	} else {
		target->mem[addr] = data;
	}
}

unsigned char
target_z80_in(Z80* z80, unsigned short addr)
{
	return -1;
}

void
target_z80_out(Z80* z80, unsigned short addr, unsigned char data)
{
	/** no job **/
}

void
update_video(TARGET* target)
{
#define TARGET_Y	16
#define TARGET_H	(240 - 16)

	unsigned char* dst = &vbuff[128 * (88 - (TARGET_H / 3)) / 2];
	unsigned char* src = &target->mem[0xa000 + (256 / 8) * TARGET_Y];
	int x, y, n1, n2, n3;

	for(y = 0; y < TARGET_H / 3; y++) {
		for(x = 0; x < (128 / 4); x++) {
			n1 = src[  0 / 8];
			n2 = src[256 / 8];
			n3 = src[512 / 8];
			*dst++ = color_table[(n1 & 0xc0) >> 2 | (n2 & 0xc0) >> 4 | (n3 & 0xc0) >> 6];
			*dst++ = color_table[(n1 & 0x30) >> 0 | (n2 & 0x30) >> 2 | (n3 & 0x30) >> 4];
			*dst++ = color_table[(n1 & 0x0c) << 2 | (n2 & 0x0c) >> 0 | (n3 & 0x0c) >> 2];
			*dst++ = color_table[(n1 & 0x03) << 4 | (n2 & 0x03) << 2 | (n3 & 0x03) >> 0];
			src++;
		}
		src += (256 / 8) * (3 - 1);
	}

#undef TARGET_Y
#undef TARGET_H
}

void
update_input(TARGET* target)
{
	unsigned char input = 0;
	if(joy & PAD_LF) input |= 0x01; /* LEFT    */
	if(joy & PAD_RI) input |= 0x02; /* RIGHT   */
	if(joy & PAD_A ) input |= 0x04; /* BUTTON1 */
	if(joy & PAD_B ) input |= 0x08; /* COIN    */
	target->mem[0xe008] = ~input; /* _ */
}

